//
//  SLIBDebugItem.h
//  PeekIt II
//
//  Created by C.K. Haun on 1/2/13.
//  Copyright (c) 2013 Ravenware Industries LLC. All rights reserved.
//

#import "SLibObject.h"
#ifndef __SLIBDBI__
#import "/Users/ckhaun/SupportLibMacOnly/SLibDebug/SLIBDebugging.h"
#endif
@interface SLIBDebugItem : SLibObject
{
    id data;
}

-(id)initWithType:(OSType) type andData:(id)inData;
-(id)initWithType:(OSType) type andName:(NSString *)name andData:(id)inData;
-(id)initWithType:(OSType) type andSubtype:(OSType)subtype andName:(NSString *)name andData:(id)inData;

-(NSString *)nameStringFromItem;
-(NSString *)valueStringFromItem;


#define mSlibDebugInt(A) ([[SLIBDebugItem alloc]initWithType:'NUM ' andSubtype:'INT ' andName:@"integer" andData:[NSNumber numberWithInt:A]])
#define mSlibDebugFloat(A) ([[SLIBDebugItem alloc]initWithType:'NUM ' andSubtype:'FLOA' andName:@"float" andData:[NSNumber numberWithFloat:A]])
#define mSlibDebugRect(A) ( [[SLIBDebugItem alloc]initWithType:'STRU' andSubtype:'RECT' andName:@"rect" andData:[NSValue valueWithBytes:&A objCType:@encode(NSRect)]])

// table adders
#define mAddSlibDebugInt(A) {     mGetMasterDebug; SLIBDebugItem *j879jhHH =       [[SLIBDebugItem alloc]initWithType:'NUM ' andSubtype:'INT ' andName:@"integer" andData:[NSNumber numberWithInt:A]]; [gDBGlobals addDebugItemToList: j879jhHH];}

#define mAddSlibDebugFloat(A) {  mGetMasterDebug; SLIBDebugItem *j879jhHH2345 =         [[SLIBDebugItem alloc]initWithType:'NUM ' andSubtype:'FLOA' andName:@"float" andData:[NSNumber numberWithFloat:A]];  [gDBGlobals addDebugItemToList: j879jhHH2345];}
#define mAddSlibDebugRect(A) { mGetMasterDebug; SLIBDebugItem *j879jhHH2345 = [[SLIBDebugItem alloc]initWithType:'STRU' andSubtype:'RECT' andName:@"rect" andData:[NSValue valueWithBytes:&A objCType:@encode(NSRect)]]; [gDBGlobals addDebugItemToList: j879jhHH2345];}

#define mAddSlibDebugTextAndInt(T,A) {     mGetMasterDebug; SLIBDebugItem *j879jhHH =       [[SLIBDebugItem alloc]initWithType:'NUM ' andSubtype:'INT ' andName:T andData:[NSNumber numberWithInt:A]]; [gDBGlobals addDebugItemToList: j879jhHH];}

#define mAddSlibDebugTextAndFloat(T,A) {  mGetMasterDebug; SLIBDebugItem *j879jhHH2345 =         [[SLIBDebugItem alloc]initWithType:'NUM ' andSubtype:'FLOA' andName:T andData:[NSNumber numberWithFloat:A]];  [gDBGlobals addDebugItemToList: j879jhHH2345];}
#define mAddSlibDebugTextAndRect(T,A) { mGetMasterDebug; SLIBDebugItem *j879jhHH2345 = [[SLIBDebugItem alloc]initWithType:'STRU' andSubtype:'RECT' andName:T andData:[NSValue valueWithBytes:&A objCType:@encode(NSRect)]]; [gDBGlobals addDebugItemToList: j879jhHH2345];}


// text
#define mAddStringToDebugText(A) {mGetMasterDebug; SLIBDebugItem *j879jhHH2345 = [[SLIBDebugItem alloc]initWithType:'TEXT' andSubtype:'NSST' andName:@"NSString" andData:A]; [gDBGlobals addToDebugText:j879jhHH2345];}




#define mAddtextPtrToDebugText(A,B) {mGetMasterDebug;NSString *fool567 =  [[NSString alloc]initWithBytes:A length:B    encoding:NSASCIIStringEncoding]; SLIBDebugItem *j879jhHH2345 = [[SLIBDebugItem alloc]initWithType:'TEXT' andSubtype:'NSST' andName:@"NSString" andData:fool567]; [gDBGlobals addToDebugText:j879jhHH2345];}
#define mSafeAddtextPtrToDebugText(A,B) {}
+(void)addsafely:(Ptr)A andLen:(NSUInteger)B;
+(void)safetadd:(NSNotification *)note;


@end
